/*
 * This file is generated by jOOQ.
 */
package de.jottyfan.timetrack.db.note.tables;


import de.jottyfan.timetrack.db.note.Keys;
import de.jottyfan.timetrack.db.note.Note;
import de.jottyfan.timetrack.db.note.enums.EnumCategory;
import de.jottyfan.timetrack.db.note.enums.EnumNotetype;
import de.jottyfan.timetrack.db.note.tables.records.TNoteRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.List;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Row6;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TNote extends TableImpl<TNoteRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>note.t_note</code>
     */
    public static final TNote T_NOTE = new TNote();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TNoteRecord> getRecordType() {
        return TNoteRecord.class;
    }

    /**
     * The column <code>note.t_note.pk</code>.
     */
    public final TableField<TNoteRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>note.t_note.title</code>.
     */
    public final TableField<TNoteRecord, String> TITLE = createField(DSL.name("title"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>note.t_note.category</code>.
     */
    public final TableField<TNoteRecord, EnumCategory> CATEGORY = createField(DSL.name("category"), SQLDataType.VARCHAR.asEnumDataType(de.jottyfan.timetrack.db.note.enums.EnumCategory.class), this, "");

    /**
     * The column <code>note.t_note.notetype</code>.
     */
    public final TableField<TNoteRecord, EnumNotetype> NOTETYPE = createField(DSL.name("notetype"), SQLDataType.VARCHAR.asEnumDataType(de.jottyfan.timetrack.db.note.enums.EnumNotetype.class), this, "");

    /**
     * The column <code>note.t_note.content</code>.
     */
    public final TableField<TNoteRecord, String> CONTENT = createField(DSL.name("content"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>note.t_note.lastchange</code>.
     */
    public final TableField<TNoteRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field("now()", SQLDataType.LOCALDATETIME)), this, "");

    private TNote(Name alias, Table<TNoteRecord> aliased) {
        this(alias, aliased, null);
    }

    private TNote(Name alias, Table<TNoteRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table());
    }

    /**
     * Create an aliased <code>note.t_note</code> table reference
     */
    public TNote(String alias) {
        this(DSL.name(alias), T_NOTE);
    }

    /**
     * Create an aliased <code>note.t_note</code> table reference
     */
    public TNote(Name alias) {
        this(alias, T_NOTE);
    }

    /**
     * Create a <code>note.t_note</code> table reference
     */
    public TNote() {
        this(DSL.name("t_note"), null);
    }

    public <O extends Record> TNote(Table<O> child, ForeignKey<O, TNoteRecord> key) {
        super(child, key, T_NOTE);
    }

    @Override
    public Schema getSchema() {
        return Note.NOTE;
    }

    @Override
    public Identity<TNoteRecord, Integer> getIdentity() {
        return (Identity<TNoteRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TNoteRecord> getPrimaryKey() {
        return Keys.T_NOTE_PKEY;
    }

    @Override
    public List<UniqueKey<TNoteRecord>> getKeys() {
        return Arrays.<UniqueKey<TNoteRecord>>asList(Keys.T_NOTE_PKEY);
    }

    @Override
    public TNote as(String alias) {
        return new TNote(DSL.name(alias), this);
    }

    @Override
    public TNote as(Name alias) {
        return new TNote(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public TNote rename(String name) {
        return new TNote(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TNote rename(Name name) {
        return new TNote(name, null);
    }

    // -------------------------------------------------------------------------
    // Row6 type methods
    // -------------------------------------------------------------------------

    @Override
    public Row6<Integer, String, EnumCategory, EnumNotetype, String, LocalDateTime> fieldsRow() {
        return (Row6) super.fieldsRow();
    }
}
